----------------------------------------------------------------
-- Extended Euclidean Algorithm for inversion(EEA_inversion.adb)
-- 
-- computes U=1/A mod f
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;

procedure EEA_inversion is
   A,F: poly_vectorm;
   S,R: poly_vectorm;
   U,V: poly_vectorm;
   auxm: poly_vectorm;
   d: integer;
   x: Bit;

begin
--   for i in 0 .. m loop 
--      Put("A(");Put(i);Put(") = "); Get(x); A(i) := x; 
--   end loop; New_Line;
--   
--   for i in 0 .. m loop 
--      Put("F(");Put(i);Put(") = "); Get(x); F(i) := x; 
--   end loop; New_Line;
--   F:= (1,1,0,0,0,0,1,1,1); -- F(x) = x^8 + x^7 + x^6 + x + 1
   F:= (1,1,0,1,1,0,0,0,1); -- F(x) = x^8 + x^4 + x^3 + x + 1
   A:= (1,1,0,1,0,1,1,1,0);
   
   for i in 0 .. m loop 
      S(i) := F(i); 
      R(i) := A(i);
      V(i) := 0;
      U(i) := 0;
      auxm(i) := 0;
   end loop;
   U(0) := 1;
   d := 0;
  
   for i in 1 .. 2*m loop
      if R(m) = 0 then
         R := rshiftm(R);
         U := rshiftm(U);
         --U := Product_alpha_Am(U,F);--
         d := d + 1;
      else
         if S(m) = 1 then
            S := m2xvvm(S,R);
            V := m2xvvm(V,U);
         end if;
         S := rshiftm(S);
         if d = 0 then
            auxm := S;
            S := R;
            R := auxm;
            
            auxm := V;
            V := U;
            U := rshiftm(auxm);

            d := 1;
         else
            U := lshiftm(U);
            d := d - 1;
         end if;
      end if;
--      Put("R = "); for i in 0 .. m loop Put(R(i)); end loop;
--      Put("  S = "); for i in 0 .. m loop Put(S(i)); end loop; 
--      Put("  U = "); for i in 0 .. m loop Put(U(i)); end loop; 
--      Put("  V = "); for i in 0 .. m loop Put(V(i)); end loop; Put("  d = "); Put(d); New_Line;
   end loop;
              
-----------------------------------------------------
   
   Put("U = "); for i in 0 .. m loop 
      Put(U(i)); 
   end loop; New_Line;

end EEA_inversion;