----------------------------------------------------------------
-- Modified Almost Inverse Algorithm for inversion (MAIA_inversion.adb)
--
-- computes inv = 1/A mod f in GF(2^M)
--
----------------------------------------------------------------

with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;


procedure MAIA_inversion is
   A,F: poly_vectorm;
   B,C,U,V: poly_vectorm;
   auxm, inv: poly_vectorm;
   ext, degree_v, degree_u, aux: integer;
   x: Bit;

begin
--   for i in 0 .. m loop 
--      Put("A(");Put(i);Put(") = "); Get(x); A(i) := x; 
--   end loop; New_Line;
--   
--   for i in 0 .. m loop 
--      Put("F(");Put(i);Put(") = "); Get(x); F(i) := x; 
--   end loop; New_Line;
   F:= (1,1,0,1,1,0,0,0,1); -- F(x) = x^8 + x^4 + x^3 + x + 1
   A:= (1,1,1,1,1,1,1,1,0);
--     A:= (0,0,1,0,1,1,0,0,0);


   for i in 0 .. m loop 
      V(i) := F(i); 
      U(i) := A(i);
      B(i) := 0;
      C(i) := 0;
      auxm(i) := 0;
      inv(i) := 0;
   end loop;
     
   B(0) := 1;
   degree_v := degreem(V);
   degree_u := degreem(U);
   aux := 0;
   ext := 0;

--      Put("  U = "); for i in 0 .. m loop  Put(U(i)); end loop;
--      Put("  V = "); for i in 0 .. m loop  Put(V(i)); end loop;
--      Put("  B = "); for i in 0 .. m loop  Put(B(i)); end loop;
--      Put("  C = "); for i in 0 .. m loop  Put(C(i)); end loop; New_Line;   

   while ext = 0 loop

      Put(" U= "); for i in 0 .. m loop  Put(U(i)); end loop;
      Put(" V= "); for i in 0 .. m loop  Put(V(i)); end loop;
      Put(" B= "); for i in 0 .. m loop  Put(B(i)); end loop;
      Put(" C= "); for i in 0 .. m loop  Put(C(i)); end loop; 
      Put(" deg_u= "); Put(degree_u);  
      Put(" deg_v= "); Put(degree_v); New_Line;
      
      while U(0) /= 1 loop
         U := lshiftm(U);
         degree_u := degree_u - 1;
         if B(0) /= 1 then
            B := lshiftm(B);
         else
            B := lshiftm(m2xvvm(B,F));
         end if;
      Put("Modif U&B, U= "); for i in 0 .. m loop  Put(U(i)); end loop;
      Put(" B= "); for i in 0 .. m loop  Put(B(i)); end loop;  
      Put(" deg_u= "); Put(degree_u); New_Line;
         
      end loop;
   
      ext := unitym(U);
      if ext = 1 then inv := B; end if;
      
      if degree_u < degree_v then 
         auxm := V;
         V := U;
         U := auxm;
      
         aux := degree_u;
         degree_u := degree_v;
         degree_v := aux;
      
         auxm := C;
         C := B;
         B := auxm;
      end if;
      
      U := m2xvvm(U,V);    
  
      degree_u := degreem(U);
    
      B := m2xvvm(B,C);      
    
   end loop;
                
-----------------------------------------------------
   
   Put("INV = "); for i in 0 .. m loop 
      Put(inv(i)); 
   end loop; New_Line;

end MAIA_inversion;