----------------------------------------------------------------
-- Binary Square and Multiply exponentiation (SQandMult.adb)
-- 
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;


procedure SQandMult_exp is
   A,F,E: poly_vector;
   B,C: poly_vector;
   x: Bit;

begin
-- loop

--   for i in 0 .. m-1 loop Put("A(");Put(i);Put(") = "); Get(x); A(i) := x; end loop; New_Line;
--   for i in 0 .. m-1 loop Put("F(");Put(i);Put(") = "); Get(x); F(i) := x; end loop; New_Line;
--   for i in 0 .. m-1 loop Put("E(");Put(i);Put(") = "); Get(x); E(i) := x; end loop; New_Line;

   F:=(1,1,0,1,1,0,0,0); -- = x^8 + x^4 + x^3 + x + 1
   A:=(1,0,1,0,0,1,0,1);
   E:=(1,0,1,0,1,0,1,0);

   
   for i in 1 .. m-1 loop B(i) := 0; end loop;
   B(0) := 1;
   
   C := A;
   for i in 0 .. m-1 loop
      if E(i) = 1 then
         B := LSBfirst(B,C,F);
      end if;
      C := LSBfirst_squarer(C,F);
      --Put("newC = "); for i in 0 .. m-1 loop Put(c(i)); end loop;
      --Put("   newB = "); for i in 0 .. m-1 loop Put(B(i)); end loop; New_Line;
   end loop;

-----------------------------------------------------
   Put("B = "); for i in 0 .. m-1 loop Put(B(i)); end loop; New_Line;
--   end loop;
end SQandMult_exp;