----------------------------------------------------------------
-- Polynomial Montgomery squaring, second version (bsquare_montgomery_v2.adb)
-- 
--
-- computes C(x) = A(x).A(x).x^(-k) mod F(x)
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Gf2m; use Gf2m;
with Finite_Fields_Gf2m; use Finite_Fields_Gf2m;


procedure Bsquarer_Montgomery_V2 is
   A,D,F: Poly_Vector;
   C: Poly2_Vector;
   X: Bit;
begin

   F := (1,1,0,0,0,0,1,1); -- F(x) = x^8 + x^7 + x^6 + x + 1
--   for I in 0 .. M-1 loop Put("A(");Put(I);Put(") = "); Get(X); A(I) := X; end loop; New_Line;
   A := (1.1,1,0,0,0,1,1);


   for I in 0 .. 2*M-2 loop C(I) := 0; end loop;
   for I in 0 .. M-1 loop C(2*I) := A(I); end loop;

   for I in 0 .. M-1 loop
   Put("c ("); put(i); put(")= "); for I in 0 .. M-1 loop Put(C(I)); end loop; New_Line;
      if C(0) = 1 then 
         C := M2xvv2(C,F);
         C(M) := M2xor(C(M),1);
      end if;
      C := Lshift2(C);   
   end loop;   
   
   for i in 0 .. m-1 loop D(i) := C(i); end loop;
   
   -----------------------------------------------------
   Put("D = "); for I in 0 .. M-1 loop Put(D(I)); end loop; New_Line;

end Bsquarer_Montgomery_V2;