----------------------------------------------------------------
-- Classic Multiplication Algorithm (classic_multiplication.adb)
-- 
-- parameter m defined in GF2m.ads
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;


procedure classic_multiplication is
   A,B,F,C: poly_vector;
   D: poly2_vector;
   R: poly_matrix_m1m2;

begin
   for i in 0 .. m-1 loop 
      Put("A(");Put(i);Put(") = "); Get(x); A(i) := x; 
   end loop; New_Line;
   
   for i in 0 .. m-1 loop 
      Put("B(");Put(i);Put(") = "); Get(x); B(i) := x; 
   end loop; New_Line;
   
   for i in 0 .. m-1 loop 
      Put("P(");Put(i);Put(") = "); Get(x); F(i) := x; 
   end loop; New_Line;
--   A:=(1,0,1,0,1,0,1,0); -- A(0):= 0; A(1):= 1; A(2):= 0; A(3):= 1; A(4):= 0; A(5):= 1; A(6):= 0; A(7):= 1;   
--   B:=(1,0,1,0,1,0,1,0);
--   F:=(1,0,0,1,1,0,0,1); -- F(0):= 1; F(1):= 0; F(2):= 0; F(3):= 1; F(4):= 1; F(5):= 0; F(6):= 0; F(7):= 1; 


   D := poly_multiplication(A,B);
   R := reduction_matrix_R(F);
   
   for j in 0 .. m-1 loop
      for i in 0 .. m-2 loop
         Put(R(j,i));
      end loop; New_Line;
   end loop;
   
   for j in 0 .. m-1 loop 
         C(j) := D(j); 
   end loop;
    
   for j in 0 .. m-1 loop
      for i in 0 .. m-2 loop
         C(j) := m2xor(C(j),m2and(R(j,i),D(m+i)));
      end loop;
   end loop;
            
-----------------------------------------------------
   
   Put("C = "); for i in 0 .. m-1 loop Put(C(i)); end loop; New_Line;

end classic_multiplication;