----------------------------------------------------------------
-- Polynomial modular squaring, second version (classic_squaring_v2.adb)
-- 
-- in GF(2^m) A.A (squaring) is very simple.
-- Then a reduction is applied.
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;


procedure classic_squaring_v2 is
   A,F,C: poly_vector;
   D: poly2_vector;
   R: poly_matrix_m1m2;
   x: Bit;

begin
--   for i in 0 .. m-1 loop 
--      Put("A(");Put(i);Put(") = "); Get(x); A(i) := x; 
--   end loop; New_Line;
--    
--   for i in 0 .. m-1 loop 
--      Put("F(");Put(i);Put(") = "); Get(x); F(i) := x; 
--   end loop; New_Line;
   A := (0,1,0,1,0,0,1,0);
   F := (1,1,0,0,0,0,1,1);


   for i in 0 .. 2*m-2 loop D(i) := 0; end loop;
   for i in 0 .. m-1 loop D(2*i) := A(i); end loop;

   R := reduction_matrix_R(F);
   
   for j in 0 .. m-1 loop
      for i in 0 .. m-2 loop
         Put(R(j,i));
      end loop; New_Line;
   end loop;
   
   for j in 0 .. m-1 loop 
         C(j) := D(j); 
   end loop;
    
   for j in 0 .. m-1 loop
      for i in 0 .. m-2 loop
         C(j) := m2xor(C(j),m2and(R(j,i),D(m+i)));
      end loop;
   end loop;
            
-----------------------------------------------------
   
   Put("C = "); for i in 0 .. m-1 loop 
      Put(C(i)); 
   end loop; New_Line;

end classic_squaring_v2;