----------------------------------------------------------------
-- Mastrovito Matrix Computation (mastrovito_matrix.adb)
-- 
-- parameters and functions defined in GF2m.ads
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Gf2m; use Gf2m;
with Finite_Fields_Gf2m; use Finite_Fields_Gf2m;

procedure Mastrovito_Matrix is
   A,F: Poly_Vector;
   P: Poly_Matrix_M2m1;
   Z: Poly_Matrix;
   procedure Print_Matrix_z is 
   begin
      for I in 0 .. M-1 loop
         for J in 0 .. M-1 loop
            Put(Z(I,J));
         end loop; New_Line;
      end loop;
   end Print_Matrix_z;

begin
   --   for i in 0 .. m-1 loop 
   --      Put("A(");Put(i);Put(") = "); Get(x); a(i) := x; 
   --   end loop; New_Line;

   --   for i in 0 .. m-2 loop
   --      for j in 0 .. m-1 loop
   --         Put("P(");Put(i);Put(",");Put(j);Put(") = "); Get(x); P(i,j) := x;
   --      end loop; New_Line;
   --   end loop;
   A:=(1,0,1,0,1,0,1,0);
   F:=(1,0,0,1,1,0,0,1); 
   P := Matrix_P(F);

   for I in 0 .. M-1 loop
      Z(I,0) := A(I);
   end loop;
  
   for I in 0 .. M-1 loop 
      for J in 1 .. M-1 loop
         Z(I,J) := 0; 
      end loop;
   end loop;
   
   Print_Matrix_z; New_Line; 
   for I in 0 .. M-1 loop
      for J in 1 .. M-1 loop
         for T in 0 .. J-1 loop
            Z(I,J) := M2xor(Z(I,J),M2and(P(J-1-T,I),A(M-1-T)));
         end loop;
         if I >= J then   
            Z(I,J) := M2xor(A(I-J),Z(I,J));        
         end if;
      end loop;
      Print_Matrix_z; New_Line; 
   end loop;

   -----------------------------------------------------
   Put("Resulting Z matrix = "); New_Line;    
   Print_Matrix_z; New_Line;   

end Mastrovito_Matrix;