----------------------------------------------------------------
-- Mastrovito Multiplication for All One Polynomials (AOPs) 
-- (mastrovito_multiplication_AOP.adb)
-- 
-- parameters and functions defined in GF2m.ads
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;

procedure mastrovito_multiplication_AOP is
   a,b,f,c: poly_vector;
   d: poly_vector;
   x,e: Bit;

begin
   for j in 0 .. m-1 loop 
         c(j) := 0; d(j) := 0;
   end loop;

   e := 0;

   for i in 0 .. m-1 loop 
      Put("A(");Put(i);Put(") = "); Get(x); a(i) := x; 
   end loop; New_Line;
   
   for i in 0 .. m-1 loop 
      Put("B(");Put(i);Put(") = "); Get(x); b(i) := x; 
   end loop; New_Line;
   
--     A:=(1,0,1,0,1,0,1,0);
--     B:=(1,0,1,0,1,0,1,0);

   for k in 0 .. m-1 loop
      for i in 0 .. k loop
         d(k) := m2xor(d(k),m2and(a(k-i),b(i)));
      end loop;
      for i in k+2 .. m-1 loop
         d(k) := m2xor(d(k),m2and(a(m-1-(i-k-2)),b(i)));
      end loop;
   end loop;

   for i in 1 .. m-1 loop
      e := m2xor(e,m2and(a(m-1-(i-1)),b(i)));
   end loop;

   for i in 0 .. m-1 loop
      c(i) := m2xor(e,d(i));
   end loop;
            
-----------------------------------------------------
   
   Put("C = "); for i in 0 .. m-1 loop 
      Put(C(i)); 
   end loop; New_Line;

end mastrovito_multiplication_AOP;