----------------------------------------------------------------
-- Mastrovito Multiplication for Trinomials 
-- (mastrovito_multiplication_trinomials.adb)
-- 
-- X*Y mod F; where F=x^m + x^k + 1
-- This implementation is for k > m/2
-- parameters and functions defined in GF2m.ads
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;

procedure mastrovito_multiplication_v2_trinomials is
   a,b,c: poly_vector;
   d: poly_vector;
   e: poly_vector2;
   h: poly_vector;
   k: integer;

begin
   for j in 0 .. m-1 loop 
         c(j) := 0; 
         h(j) := 0;
   end loop;

--   for i in 0 .. m-1 loop 
--      Put("A(");Put(i);Put(") = "); Get(x); a(i) := x; 
--   end loop; New_Line;
--   
--   for i in 0 .. m-1 loop 
--      Put("B(");Put(i);Put(") = "); Get(x); b(i) := x; 
--   end loop; New_Line;
--   
--   Put("k = "); Get(k);
   A:=(1,1,1,1,1,1,1,1);
   B:=(1,0,0,1,1,1,1,1);   
   k := 4;

   d := vector_D(a,b);
   e := vector_E(a,b);
   
   Put("M = "); Put(m);  Put("  K = "); Put(k); New_Line;
   Put("C = "); for i in 0 .. m-1 loop Put(c(i)); end loop; New_Line;
   Put("E = "); for i in 0 .. m-2 loop Put(e(i)); end loop; New_Line;
   Put("D = "); for i in 0 .. m-2 loop Put(d(i)); end loop; New_Line;
   
   for j in reverse (2*k-m-1) .. k-2 loop
      Put("J = ");put(j); Put(" J+M-K = ");put(j+m-k);New_Line;
      if j >= 0 then
        h(j) := m2xor(e(j),e(j+m-k));
      end if;
   end loop;
      
   for j in reverse 0 .. (2*k-m-2) loop
      Put(" JJ = ");put(j); Put(" J+M-K = ");put(j+m-k); New_Line;
      h(j) := m2xor(e(j),h(j+m-k));
   end loop;
   
   Put("h = "); for i in 0 .. m-1 loop Put(h(i)); end loop; New_Line;
   
   for j in 0 .. k-2 loop
      c(j) := m2xor(d(j),h(j));
   end loop;
   
   Put("C1= "); for i in 0 .. m-1 loop Put(c(i)); end loop; New_Line;
 
   c(k-1) := m2xor(d(k-1),e(k-1));
   for j in k .. (2*k-2) loop
      if j < m-1 then
      c(j) := m2xor(d(j),m2xor(e(j),h(j-k)));
      end if;
   end loop;
   for j in (2*k-1) .. m-2 loop  
      c(j) := m2xor(d(j),m2xor(e(j),e(j-k)));
   end loop;
   c(m-1) := m2xor(d(m-1),h(m-k-1));
            
-----------------------------------------------------
   
   Put("C = "); for i in 0 .. m-1 loop 
      Put(c(i)); 
   end loop; New_Line;

end mastrovito_multiplication_v2_trinomials;