----------------------------------------------------------------
-- Matrix P computation (matrix_multiplication.adb)
-- 
-- parameters and functions defined in GF2m.ads
-- Computes the Matrix P as explained in 7.17 and 7.18
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Gf2m; use Gf2m;
with Finite_Fields_Gf2m; use Finite_Fields_Gf2m;

  
procedure Matrix_P is
   F: Poly_Vector;
   P: Poly_Matrix_M2m1;
   X: Bit;
   procedure Print_Matrix is 
   begin
      for I in 0 .. M-2 loop
         for J in 0 .. M-1 loop
            Put(P(I,J));
         end loop; 
         New_Line;
      end loop;
   end Print_Matrix;

begin
   for I in 0 .. M-1 loop 
      Put("F(");Put(I);Put(") = "); Get(X); F(I) := X; 
   end loop; New_Line;
   --F:=(1,0,0,1,1,0,0,1);
 
   for J in 0 .. M-1 loop
      P(0,J) := F(J);
   end loop;
   
   for I in 1 .. M-2 loop 
      for J in 0 .. M-1 loop
         P(I,J) := 0; 
      end loop;
   end loop;
       
   for I in 1 .. M-2 loop
      for J in 0 .. M-1 loop
         if J = 0 then 
            P(I,J) := P(I-1,M-1);
         else
            P(I,J) := M2xor(P(I-1,J-1),M2and(P(I-1,M-1),P(0,J))); 
         end if;
      end loop;
   end loop;

   -----------------------------------------------------
   Put("Resulting P matrix = "); New_Line;  
   Print_Matrix; New_Line; 

end Matrix_P;
