----------------------------------------------------------------
-- Matrix P computation (matrix_multiplication.adb)
-- 
-- parameters and functions defined in GF2m.ads
-- Computes the Matrix P as explained in 7.17 and 7.18
-- Version GS
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Gf2m; use Gf2m;
with Finite_Fields_Gf2m; use Finite_Fields_Gf2m;

  
procedure Matrix_P_2 is
   F: Poly_Vector;
   P: Poly_Matrix_M2m1;
   X: Bit;
   procedure Print_matrix is 
   begin
      for I in 0 .. M-2 loop
         for J in 0 .. M-1 loop
            Put(P(I,J));
         end loop; 
         New_Line;
      end loop;
   end Print_matrix;

begin
   --   for i in 0 .. m-1 loop 
   --      Put("F(");Put(i);Put(") = "); Get(x); F(i) := x; 
   --   end loop; New_Line;
   F:=(1,0,0,1,1,0,0,1);
 
   for J in 0 .. M-1 loop
      P(0,J) := F(J);
   end loop;
   
--   for I in 1 .. M-2 loop 
--      for J in 0 .. M-1 loop
--         P(I,J) := 0; 
--      end loop;
--   end loop;
       
   for I in 1 .. M-2 loop
      P(I,0) := P(I-1,M-1);
      for J in 1 .. M-1 loop
         P(I,J) := M2xor(P(I-1,J-1),M2and(P(I-1,M-1),P(0,J))); 
      end loop;
   Print_matrix; New_Line; 
   end loop;

   -----------------------------------------------------
   Put("Resulting P matrix (2) = "); New_Line;  
   Print_matrix; New_Line; 

end Matrix_P_2;
