--------------------------------------------------------------------------------
-- Simple testbench for "poly_multiplier" module (for m=8)
--
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
use work.classic_multiplier_parameters.all;

ENTITY test_poly_mult_vhd IS
END test_poly_mult_vhd;

ARCHITECTURE behavior OF test_poly_mult_vhd IS 

  -- Component Declaration for the Unit Under Test (UUT)
  COMPONENT poly_multiplier
  PORT(
    a : IN std_logic_vector(m-1 downto 0);
    b : IN std_logic_vector(m-1 downto 0);
    d : OUT std_logic_vector(2*m-2 downto 0)
    );
  END COMPONENT;

  --Inputs
  SIGNAL a :  std_logic_vector(m-1 downto 0) := (others=>'0');
  SIGNAL b :  std_logic_vector(m-1 downto 0) := (others=>'0');

  --Outputs
  SIGNAL d :  std_logic_vector(2*m-2 downto 0);

BEGIN

  -- Instantiate the Unit Under Test (UUT)
  uut: poly_multiplier PORT MAP( a => a, b => b, d => d );

  tb : PROCESS
  BEGIN
    -- Wait 100 ns for global reset to finish
    wait for 100 ns;
    a <= "10101010";
    b <= "10101010";
    wait for 100 ns;
    assert (d = "100010001000100") report "ERROR in mult"  severity FAILURE;
    a <= "10101010";
    b <= "00000000";
    wait for 100 ns;
    assert (d = "000000000000000") report "ERROR in mult"  severity FAILURE;
    a <= "11111111";
    b <= "10101010";
    wait for 100 ns;
    assert (d = "110011001100110") report "ERROR in mult"  severity FAILURE;
    a <= "10101010";
    b <= "01010101";
    wait for 100 ns;
    assert (d = "010001000100010") report "ERROR in mult"  severity FAILURE;
    a <= "01010101";
    b <= "01010101";
    wait for 100 ns;
    assert (d = "001000100010001") report "ERROR in mult"  severity FAILURE;

    wait; -- will wait forever
  END PROCESS;

END;
